#pragma once

enum {
	NOCONDITION,
	COUNTDOWNTIMER,
	COMMAND,
	BRING,
	ACCUMULATE,
	KILL,
	COMMADNTHEMOST,
	COMMANDSTHEMOSTAT,
	MOSTKILLS,
	HIGHESTSCORE,
	MOSTRESOURCES,
	SWITCH,
	ELAPSEDTIME,
	NACD,
	OPPONENTS,
	DEATHS,
	COMMANDTHELEAST,
	COMMANDTHELEASTAT,
	LEASTKILLS,
	LOWESTSCORE,
	LEASTRESOURCES,
	SCORE,
	ALWAYS,
	NEVER
};

enum {
	NOACTION,
	VICTORY,
	DEFEAT,
	PRESERVETRIGGER,
	WAIT,
	PAUSEGAME,
	UNPAUSEGAME,
	TRANSMISSION,
	PLAYWAV,
	DISPLAYTEXTMESSAGE,
	CENTERVIEW,
	CREATEUNITWITHPROPERTIES,
	SETMISSIONOBJECTIVES,
	SETSWITCH,
	SETCOUNTDOWNTIMER,
	RUNAISCRIPT,
	RUNAISCRIPTATLOCATION,
	LEADERBOARDCONTROL,
	LEADERBOARDCONTROLATLOCATION,
	LEADERBOARDRECOURCES,
	LEADERBOARDKILLS,
	LEADERBOARDPOINTS,
	KILLUNIT,
	KILLUNITATLOCATION,
	REMOVEUNIT,
	REMOVEUNITATLOCATION,
	SETRESOURCES,
	SETSCORE,
	MINIMAPPING,
	TALKINGPORTRAIT,
	MUTEUNITSPEECH,
	UNMUTEUNITSPEECH,
	LEADERBOARDCOMPUTERPLAYERS,
	LEADERBOARDGOALCONTROL,
	LEADERBOARDGOALCONTROLATLOCATION,
	LEADERBOARDGOALRESOURCES,
	LEADERBOARDGOALKILLS,
	LEADERBOARDGOALPOINTS,
	MOVELOCATION,
	MOVEUNIT,
	LEADERBOARDGREED,
	SETNEXTSCENARIO,
	SETDOODADSTATE,
	SETINVINCIBILLITY,
	CREATEUNIT,
	SETDEATHS,
	ORDER,
	COMMENT,
	GIVEUNITSTOPLAYER,
	MODIFYUNITHITPOINTS,
	MODIFYUNITENERGY,
	MODIFYUNITSHIELDPOINTS,
	MODIFYUNITRESOURCEAMOUNT,
	MODIFYUNITHANGERCOUNT,
	PAUSETIMER,
	UNPAUSETIMER,
	DRAW,
	SETALLIANCESTATUS
};

enum FieldType {
	FIELDTYPE_NONE,
	FIELDTYPE_NUMBER,
	FIELDTYPE_ALLYSTATUS,
	FIELDTYPE_COMPARISON,
	FIELDTYPE_MODIFIER,
	FIELDTYPE_ORDER,
	FIELDTYPE_PLAYER,
	FIELDTYPE_PROPSTATE,
	FIELDTYPE_RESOURCE,
	FIELDTYPE_SCORE,
	FIELDTYPE_SWITCHACTION,
	FIELDTYPE_SWITCHSTATE,
	FIELDTYPE_AISCRIPT,
	FIELDTYPE_COUNT,
	FIELDTYPE_UNIT,
	FIELDTYPE_LOCATION,
	FIELDTYPE_STRING,
	FIELDTYPE_SWITCHNAME,
};

enum TrigField {
	CONDFIELD_NONE = 0,
	
	// Condition fields
	CONDFIELD_LOCID,
	CONDFIELD_PLAYER,
	CONDFIELD_RES,
	CONDFIELD_UID,
	CONDFIELD_SETTING,
	CONDFIELD_CONDTYPE,
	CONDFIELD_RES_SETTING,
	CONDFIELD_PROP,

	ACTFIELD_NONE = 0,
	
	// Action fields
	ACTFIELD_LOCID,
	ACTFIELD_STRID,
	ACTFIELD_WAVID,
	ACTFIELD_TIME,
	ACTFIELD_PLAYER,
	ACTFIELD_TARGET,
	ACTFIELD_SETTING,
	ACTFIELD_ACTTYPE,
	ACTFIELD_NUM,
	ACTFIELD_PROP
};

#define MAX_FIELD_NUM 50

struct FieldTypePair {
	int Field;
	FieldType Type;
};


struct TriggerStatementDecl {
	int stmt_type;
	const char* stmt_name;
	FieldTypePair fields[MAX_FIELD_NUM];
};
